searchNodes=[{"doc":"Code to emit Elixir and C code from a single &quot;clixir&quot; (.cx) file.Pull this in through a use Clixir statement.","ref":"Clixir.html","title":"Clixir","type":"module"},{"doc":"Define a C function. The function body will be translated into C. The function definition will be available in Elixir and can be called like any other function. The process is largely transparent except for the somewhat arbitrary shortcomings of the C backend.The elixir code is inserted directly in the module. The C code is added to a special attribute that a __before_compile__ macro reads for further processing.","ref":"Clixir.html#def_c/2","title":"Clixir.def_c/2","type":"macro"},{"doc":"Clixir application. This starts the Clixir wrapper server that monitors and talks to the clixir executable.","ref":"Clixir.Application.html","title":"Clixir.Application","type":"module"},{"doc":"","ref":"Clixir.Application.html#start/2","title":"Clixir.Application.start/2","type":"function"},{"doc":"Code to emit the C code parts from ClixirNote that this code currently is very ad hoc and supports a very small subset of C. It has - hopefully - helpful error messages for when it does not understand C so it should be easy to add things. However, it really needs some cleanup to be less ad hoc and more like what you learn in compiler writing class ;-)","ref":"Clixir.CBackend.html","title":"Clixir.CBackend","type":"module"},{"doc":"","ref":"Clixir.CBackend.html#generate_code/5","title":"Clixir.CBackend.generate_code/5","type":"function"},{"doc":"Code that is used by both the C and Elixir backends.","ref":"Clixir.CodeGenHelpers.html","title":"Clixir.CodeGenHelpers","type":"module"},{"doc":"Make a C function name from the module name and the function name. This basically just smacks them together to make them globally unique.","ref":"Clixir.CodeGenHelpers.html#cfun_name/2","title":"Clixir.CodeGenHelpers.cfun_name/2","type":"function"},{"doc":"This module does the actual work of Clixir.__before_compile__/1. It writes out the C and GNU gperf code fragments which later on get combined to form the project's clixir executable.Due to the nature of the system, re-compilation is mostly unavoidable: if we are called, then apparently the Elixir compiler decided that the Clixir-using module was out of date. We could go all smart and drop a hash over the C code on disk and check whether it was changed, but the executables we generate are small so recompilation is not a big issue. Therefore, we set things up so that recompilations happens rather often instead of trying to avoid it.","ref":"Clixir.CodeWriter.html","title":"Clixir.CodeWriter","type":"module"},{"doc":"","ref":"Clixir.CodeWriter.html#write_code/1","title":"Clixir.CodeWriter.write_code/1","type":"function"},{"doc":"Code to emit the Elixir code parts from Clixir","ref":"Clixir.ElixirBackend.html","title":"Clixir.ElixirBackend","type":"module"},{"doc":"Generate Elixir code to call the C function in the module. The parameter list will be marshalled as the binary representation of the erlang term.","ref":"Clixir.ElixirBackend.html#generate_code/3","title":"Clixir.ElixirBackend.generate_code/3","type":"function"},{"doc":"This wraps the clixir executable and makes it accessible. For now, we hardcode the executable and generate one massive one until there's a use case to change this ;-)","ref":"Clixir.Server.html","title":"Clixir.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Clixir.Server.html#child_spec/1","title":"Clixir.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Clixir.Server.html#init/1","title":"Clixir.Server.init/1","type":"function"},{"doc":"Send a command.","ref":"Clixir.Server.html#send_command/2","title":"Clixir.Server.send_command/2","type":"function"},{"doc":"","ref":"Clixir.Server.html#start_link/1","title":"Clixir.Server.start_link/1","type":"function"},{"doc":"Holds the state:port is the Port that uderzo is running under","ref":"Clixir.Server.State.html","title":"Clixir.Server.State","type":"module"},{"doc":"This tasks collects all the fragments that the Clixir macro invocations have generated, and does the finishing job. You need to add this compiler to the Mix configuration of your project, typically as a step between the regular compilation and elixir_make:def project() do app: myapp, compilers: Mix.compilers ++ [:clixir, :elixir_make] endThe source is generated in c_src/&lt;&lt;application&gt;&gt;.c and will be overwritten!","ref":"Mix.Tasks.Compile.Clixir.html","title":"Mix.Tasks.Compile.Clixir","type":"task"},{"doc":"","ref":"Mix.Tasks.Compile.Clixir.html#run/1","title":"Mix.Tasks.Compile.Clixir.run/1","type":"function"},{"doc":"ClixirDisclaimer: for now, this is design documentation, actual implementation may have differences. See the code, the test, and the demo app for the truthWe write the C code in Elixir and use macros to generate both the Elixir bindings and the C code. This idea was blatantly stolen from Squeak Smalltalk. As we aim for a very low level interface, all the functions will have the same structure in C: unmarshall arguments, make call, marshall return values; so &quot;Clixir&quot; can start out simple. defgfx glfw_get_cursor_pos(window, pid) do cdecl &quot;GLFWwindow *&quot;: window cdecl erlang_pid: pid cdecl double: [mx, my] glfwGetCursorPos(window, &amp;mx, &amp;my) {pid, {mx, my}} endwill result in this Elixir code (both a regular and a blocking synchronous version are generated, although I think the sync version shouldn't be used ;-)): @spec glfw_get_cursor_pos(integer, pid) :: none def glfw_get_cursor_pos(window, pid) do GraphicsServer.send_command(GraphicsServer, {:glfw_get_cursor_pos, window, pid}) end @spec glfw_get_cursor_pos_s(integer) :: {float, float} def glfw_get_cursor_pos(window) do glfw_get_cursor_pos(window, self) receive do {mx, my} when is_float(mx) and is_float(my) -&gt; {mx, my} end endand the following C code:static void _dispatch_glfw_get_cursor_pos(const char *buf, unsigned short len, int *index) { GLFWwindow *window; erlang_pid pid; double mx, my; assert(ei_decode_longlong(buf, index, (long long *) &amp;window) == 0); assert(ei_decode_pid(buf, index, &amp;pid) == 0); glfwGetCursorPos(window, &amp;mx, My); ei_encode_version(response, &amp;response_index); ei_encode_tuple_header(response, &amp;response_index, 2); ei_encode_pid(response, &amp;response_index, &amp;pid); ei_encode_tuple_header(response, &amp;response_index, 2); ei_encode_double(response, &amp;response_index, mx); ei_encode_double(response, &amp;response_index, my); write_response_bytes(response, response_index); }","ref":"clixir.html","title":"Clixir","type":"extras"},{"doc":"Although Clixir was specifically created for Uderzo, it is very easy to use stand-alone. Uderzo's repository has a Clixir example application that shows a minimal &quot;hello, world&quot;. The following files are relevant:c_src/example.hx is the required Clixir header file. This file should pull in all the includes, define macros, etcetera - stuff that cannot be (yet) done in Clixir. It is slapped on top of the generated code;lib/example.ex is a minimal Elixir module that uses the Clixir def_c macro. Please take the warning about not sending anything to stdout to heart, because it's likely to really mess up things :-).Finally, lib/example_application.ex is the &quot;application&quot;. It invokes the Clixir-generated method. Note how it looks like any other Elixir invocation - the whole idea is to make invoking C code as transparent as possible.To get this all to build, some things need to be setup correctly:mix.exs needs to incorporate the Clixir compiler and setup the build environment for the elixir_make plugin so that we can find the correct location for the Erlang libraries we use for deserializing Erlang terms.config/config.exs must have a :clixir configuration that points to the application that provides the clixir executable. You might have multiple dependencies that use Clixir and they each build their own version of this executable, but only one can be started at run-time. Usually, your top-level application integrates everything and that application's executable will have a clixir executable that incorporates all Clixir code from your application and your dependencies.Finally, Makefile is basically boilerplate code you can copy-paste; it takes the generated C file in c_src (containing all Clixir functions in all applications and a gperf jump table) and compiles it together with the Clixir run-time library into the executable that will be started.","ref":"clixir.html#usage","title":"Clixir - Usage","type":"extras"},{"doc":"Performance of the protocol should be very good, for the following reasons:the ei_decode_.. family seems to do very little copying and is efficient by keeping a pointer in a buffer that moves up; ideally, this means that a message is scanned in a single loop the length of the message;dispatching is done using a gperf generated hashtable. These perfect hashtables are very fast, usually requiring just two memory lookups to find the function pointer to dispatch to.the default messaging flow is fully asynchronous so that waiting for I/O should never be a blocker.One of the Uderzo examples I coded runs 100 &quot;boids&quot; at 100fps, meaning that 10,000 draw commands are sent every second; the Clixir executable takes negligible CPU.","ref":"clixir.html#performance","title":"Clixir - Performance","type":"extras"}]